﻿<%@ Page Language="VB" MasterPageFile="~/BbsMaster.master" Title="掲示板アプリ（個別記事表示）" Theme="Main" %>
<%@ Import Namespace="System.Data" %>
<script runat="server">
    Protected Sub Page_Load(ByVal sender As Object, ByVal e As System.EventArgs)
        If Request.QueryString("id") Is Nothing Or Request.QueryString("id") = "" Then
            fv.ChangeMode(FormViewMode.Insert)
        End If
    End Sub
    
    Protected Sub sds_Deleting(ByVal sender As Object, ByVal e As System.Web.UI.WebControls.SqlDataSourceCommandEventArgs)
        Dim txtPasswd As TextBox = DirectCast(fv.FindControl("txtPasswd"), TextBox)
        e.Command.Parameters("@passwd").Value = txtPasswd.Text
    End Sub

    Protected Sub sds_Deleted(ByVal sender As Object, ByVal e As System.Web.UI.WebControls.SqlDataSourceStatusEventArgs)
        If e.AffectedRows = 0 Then
            Page.ClientScript.RegisterStartupScript(Me.GetType(), "err", "window.alert('パスワードが間違っています。')", True)
        Else
            Response.Redirect("Bbs.aspx")
        End If
    End Sub

    Protected Sub fv_DataBound(ByVal sender As Object, ByVal e As System.EventArgs)
        Dim cok As HttpCookie = Request.Cookies("name")
        Select Case fv.CurrentMode
            Case FormViewMode.ReadOnly
                Dim view As DataRowView = DirectCast(fv.DataItem, DataRowView)
                If Not IsDBNull(view("idata")) Then
                    Dim img As Image = DirectCast(fv.FindControl("img"), Image)
                    img.Visible = True
                End If
            Case FormViewMode.Insert
                If cok IsNot Nothing Then
                    Dim txtNam As TextBox = DirectCast(fv.FindControl("txtNam"), TextBox)
                    txtNam.Text = Request.Cookies("name").Value
                End If
            Case FormViewMode.Edit
                Dim txtSubject As TextBox = DirectCast(fv.FindControl("txtSubject"), TextBox)
                Dim txtNam As TextBox = DirectCast(fv.FindControl("txtNam"), TextBox)
                Dim txtBody As TextBox = DirectCast(fv.FindControl("txtBody"), TextBox)
                Dim txtPasswd As TextBox = DirectCast(fv.FindControl("txtPasswd"), TextBox)
                txtSubject.Text = "Re: " & txtSubject.Text
                txtBody.Text = ""
                txtPasswd.Text = ""
                If cok IsNot Nothing Then
                    txtNam.Text = Request.Cookies("name").Value
                End If
        End Select
    End Sub

    Protected Sub sds_Updated(ByVal sender As Object, ByVal e As System.Web.UI.WebControls.SqlDataSourceStatusEventArgs)
        Response.Redirect("Bbs.aspx")
    End Sub
    
    Protected Sub sds_Inserted(ByVal sender As Object, ByVal e As System.Web.UI.WebControls.SqlDataSourceStatusEventArgs)
        Response.Redirect("Bbs.aspx")
    End Sub

    Protected Sub sds_Inserting(ByVal sender As Object, ByVal e As System.Web.UI.WebControls.SqlDataSourceCommandEventArgs)
        Me.AddCookie(e.Command.Parameters("@nam").Value)
        Response.Write(e.Command.Parameters("@idata").Value)
    End Sub

    Protected Sub sds_Updating(ByVal sender As Object, ByVal e As System.Web.UI.WebControls.SqlDataSourceCommandEventArgs)
        Me.AddCookie(e.Command.Parameters("@nam").Value)
    End Sub
    
    Protected Sub AddCookie(ByVal name As String)
        Dim cok As New HttpCookie("name", name)
        cok.Expires = DateTime.Now.AddMonths(3)
        Response.AppendCookie(cok)
    End Sub

    Protected Sub fv_ItemInserting(ByVal sender As Object, ByVal e As System.Web.UI.WebControls.FormViewInsertEventArgs)
        Dim idata As FileUpload = DirectCast(fv.FindControl("idata"), FileUpload)
        e.Values.Add("idata", idata.FileBytes)
    End Sub

    Protected Sub fv_ItemUpdating(ByVal sender As Object, ByVal e As System.Web.UI.WebControls.FormViewUpdateEventArgs)
        Dim idata As FileUpload = DirectCast(fv.FindControl("idata"), FileUpload)
        e.NewValues.Add("idata", idata.FileBytes)
    End Sub
</script>

<asp:Content ID="ctt" ContentPlaceHolderID="cph" Runat="Server">
    <asp:FormView ID="fv" runat="server" DataKeyNames="id" DataSourceID="sds" EmptyDataText="該当するデータが存在しません" OnDataBound="fv_DataBound" OnItemInserting="fv_ItemInserting" OnItemUpdating="fv_ItemUpdating">
        <EditItemTemplate>
            件名：<asp:TextBox ID="txtSubject" runat="server" Text='<%# Bind("subject") %>' Columns="50" MaxLength="100"></asp:TextBox><br />
            名前：<asp:TextBox ID="txtNam" runat="server" Text='<%# Bind("nam") %>' MaxLength="35"></asp:TextBox><br />
            <asp:TextBox ID="txtBody" runat="server" Text='<%# Bind("body") %>' Columns="45" Rows="7" TextMode="MultiLine"></asp:TextBox><br />
            添付画像：<asp:FileUpload ID="idata" runat="server" /><br />
            削除用パスワード：<asp:TextBox ID="txtPasswd" runat="server" Text='<%# Bind("passwd") %>' Columns="5" MaxLength="10" TextMode="Password"></asp:TextBox><br />
            <asp:HiddenField ID="hdnId" runat="server" Value='<%# Bind("id") %>' />
            <asp:Button ID="btnUpdate" runat="server" CommandName="Update" Text="投稿" />
            <asp:Button ID="btnCancel" runat="server" CommandName="Cancel" Text="戻る" />
        </EditItemTemplate>
        <InsertItemTemplate>
            件名：<asp:TextBox ID="txtSubject" runat="server" Text='<%# Bind("subject") %>' Columns="50" MaxLength="100"></asp:TextBox><br />
            名前：<asp:TextBox ID="txtNam" runat="server" Text='<%# Bind("nam") %>' MaxLength="35"></asp:TextBox><br />
            <asp:TextBox ID="txtBody" runat="server" Text='<%# Bind("body") %>' Columns="45" Rows="7" TextMode="MultiLine"></asp:TextBox><br />
            添付画像：<asp:FileUpload ID="idata" runat="server" /><br />
            削除用パスワード：<asp:TextBox ID="txtPasswd" runat="server" Text='<%# Bind("passwd") %>' Columns="5" MaxLength="10" TextMode="Password"></asp:TextBox><br />
            <asp:Button ID="btnInsert" runat="server" CommandName="Insert" Text="投稿" />
            <asp:Button ID="btnCancel" runat="server" Text="戻る" PostBackUrl="~/Bbs.aspx" />
        </InsertItemTemplate>
        <ItemTemplate>
            <asp:Label ID="lblId" runat="server" Text='<%# Eval("id") %>'></asp:Label>：
                <asp:Label ID="lblSubject" runat="server" Text='<%# Eval("subject") %>'></asp:Label>
            (<asp:Label ID="lblNam" runat="server" Text='<%# Eval("nam") %>'></asp:Label>&nbsp;
            <asp:Label ID="lblLastModified" runat="server" Text='<%# Eval("last_modified","{0:yyyy年MM月dd日 HH:mm:ss}") %>'></asp:Label>)<br />
            <br />
            <asp:Label ID="lblBody" runat="server" Text='<%# Eval("body") %>'></asp:Label><br />
            <br />
            <asp:Image ID="img" runat="server" ImageUrl='<%# Eval("id","BbsImage.aspx?id={0}") %>' Visible="False" /><br />
            <strong>削除用パスワード：<asp:TextBox ID="txtPasswd" runat="server" Columns="5" TextMode="Password"></asp:TextBox></strong><br />
            <br />
            <asp:Button ID="btnDelete" runat="server" CommandName="Delete" Text="削除" />&nbsp;<asp:Button
                ID="btnRes" runat="server" Text="返信" CommandName="Edit" />
        </ItemTemplate>
    </asp:FormView>
    <asp:SqlDataSource ID="sds" runat="server" ConnectionString="<%$ ConnectionStrings:myDb %>"
        DeleteCommand="UPDATE Bbs SET deleted=1 WHERE id=@id AND passwd=@passwd" InsertCommand="INSERT INTO Bbs(nam, subject, body, passwd, deleted, parent, last_modified, idata) VALUES (@nam, @subject, @body, @passwd, 0, 0, CURRENT_TIMESTAMP, @idata)"
        SelectCommand="SELECT id, nam, subject, REPLACE(body, CHAR(13) + CHAR(10), '<br />') AS body, passwd, deleted, parent, last_modified, idata FROM Bbs WHERE (id = @id) AND (deleted = 0)" OnDeleting="sds_Deleting" OnDeleted="sds_Deleted" UpdateCommand="INSERT INTO Bbs(nam, subject, body, passwd, deleted, parent, last_modified, idata) VALUES (@nam, @subject, @body, @passwd, 0, @id, CURRENT_TIMESTAMP ,@idata)" OnUpdated="sds_Updated" OnInserted="sds_Inserted" OnInserting="sds_Inserting" OnUpdating="sds_Updating">
        <DeleteParameters>
            <asp:Parameter Name="id" Type="Int32" />
            <asp:Parameter Name="passwd" Type="String" />
        </DeleteParameters>
        <SelectParameters>
            <asp:QueryStringParameter Name="id" QueryStringField="id" Type="Int32" />
        </SelectParameters>
        <InsertParameters>
            <asp:Parameter Name="nam" Type="String" />
            <asp:Parameter Name="subject" Type="String" />
            <asp:Parameter Name="body" Type="String" />
            <asp:Parameter Name="passwd" Type="String" />
            <asp:Parameter Name="idata" />
        </InsertParameters>
        <UpdateParameters>
            <asp:Parameter Name="nam" />
            <asp:Parameter Name="subject" />
            <asp:Parameter Name="body" />
            <asp:Parameter Name="passwd" />
            <asp:Parameter Name="id" />
            <asp:Parameter Name="idata" />
        </UpdateParameters>
    </asp:SqlDataSource>
</asp:Content>

