﻿<%@ Page Language="VB" MasterPageFile="~/BbsMaster.master" Title="掲示板アプリ（スレッド一覧）" %>
<%@ Import Namespace="System.Data.Common" %>
<script runat="server">
    Protected Sub Page_Load(ByVal sender As Object, ByVal e As System.EventArgs)
        Dim pag As Integer = 1
        Dim record As Integer = 0       
        If Request.QueryString("page") IsNot Nothing And Request.QueryString("page") <> "" Then
            pag = Int32.Parse(Request.QueryString("page"))
            record = (pag - 1) * 5
        End If

        Dim flag As Boolean = Me.AddChildArticles(0, tree.Nodes, record)

        If pag > 1 Then
            lnkPrev.NavigateUrl = "Bbs.aspx?page=" & pag - 1
            lnkPrev.Visible = True
        End If
        If flag Then
            lnkNext.NavigateUrl = "Bbs.aspx?page=" & pag + 1
            lnkNext.Visible = True
        End If
        If pag > 1 And flag Then ltrSep.Visible = True
    End Sub

    Protected Function AddChildArticles(ByVal parent As Integer, ByVal nodes As TreeNodeCollection, ByVal record As Integer) As Boolean
        Dim result As Boolean = False
        sds.SelectParameters.Clear()
        sds.SelectParameters.Add("parent", parent)
       
        Dim reader As DbDataReader = sds.Select(DataSourceSelectArguments.Empty)
        Dim cnt As Integer = 0
        Do While reader.Read()
            If parent = 0 Then
                If record + 4 < cnt Then
                    result = True
                    Exit Do
                End If
                cnt = cnt + 1
                If record >= cnt Then Continue Do
            End If
            
            Dim node As New TreeNode()
            If reader("deleted") = True Then
                node.NavigateUrl = "Bbs.aspx"
                node.Text = "削除済み"
            Else
                node.NavigateUrl = "BbsShow.aspx?id=" & reader("id")
                node.Text = String.Format("{0}. {1} {2}（{3:yyyy年MM月dd日 HH:mm:ss}）", reader("id"), reader("subject"), reader("nam"), reader("last_modified"))
            End If
            Me.AddChildArticles(reader("id"), node.ChildNodes, False)
            nodes.Add(node)
        Loop
        Return result
    End Function
</script>

<asp:Content ID="ctt" ContentPlaceHolderID="cph" Runat="Server">
    <asp:TreeView ID="tree" runat="server" ImageSet="News" NodeIndent="10" ShowLines="True">
        <ParentNodeStyle Font-Bold="False" />
        <HoverNodeStyle Font-Underline="True" />
        <SelectedNodeStyle Font-Underline="True" HorizontalPadding="0px" VerticalPadding="0px" />
        <NodeStyle Font-Names="Arial" Font-Size="10pt" ForeColor="Black" HorizontalPadding="5px"
            NodeSpacing="0px" VerticalPadding="0px" />
    </asp:TreeView>
    <asp:SqlDataSource ID="sds" runat="server" ConnectionString="<%$ ConnectionStrings:myDb %>" SelectCommand="SELECT [id], [subject], [nam], [deleted], [last_modified] FROM [Bbs] WHERE ([parent] = @parent) ORDER BY [last_modified] DESC" DataSourceMode="DataReader" ProviderName="<%$ ConnectionStrings:myDb.ProviderName %>">
        <SelectParameters>
            <asp:Parameter Name="parent" Type="Int32" />
        </SelectParameters>
    </asp:SqlDataSource>
    <br />
    <asp:HyperLink ID="lnkPrev" runat="server" Visible="False">＜前ページへ</asp:HyperLink>
    <asp:Literal ID="ltrSep" runat="server" Text="｜" Visible="False"></asp:Literal>
    <asp:HyperLink ID="lnkNext" runat="server" Visible="False">次ページへ＞</asp:HyperLink>
</asp:Content>