﻿<%@ Application Language="VB" %>
<%@ Import Namespace="System.Net.Mail" %>
<script runat="server">

    Sub Application_Start(ByVal sender As Object, ByVal e As EventArgs)
        ' アプリケーションのスタートアップで実行するコードです
    End Sub
    
    Sub Application_End(ByVal sender As Object, ByVal e As EventArgs)
        ' アプリケーションのシャットダウンで実行するコードです
    End Sub
        
    Sub Application_Error(ByVal sender As Object, ByVal e As EventArgs)
        Dim Context As HttpContext = DirectCast(sender, HttpApplication).Context
        Dim err As Exception = Context.Server.GetLastError().InnerException
        If err IsNot Nothing Then
            Dim builder As New StringBuilder()
            builder.Append(Context.Request.RawUrl)
            builder.Append(Chr(13) & Chr(10))
            builder.Append(err.Message)
            builder.Append(Chr(13) & Chr(10))
            Dim mail As New MailMessage()
            mail.To.Add(New MailAddress("CQW15204@nifty.com"))
            mail.Subject = String.Format("エラー発生（{0}）", DateTime.Now.ToString())
            mail.Body = builder.ToString()
            Dim smtp As New SmtpClient()
            smtp.Send(mail)
        End If
    End Sub

    Sub Session_Start(ByVal sender As Object, ByVal e As EventArgs)
        ' 新規セッションを開始したときに実行するコードです
    End Sub

    Sub Session_End(ByVal sender As Object, ByVal e As EventArgs)
        ' セッションが終了したときに実行するコードです 
        ' メモ: Web.config ファイル内で sessionstate モードが InProc に設定されているときのみ、
        ' Session_End イベントが発生します。session モードが StateServer か、または SQLServer に 
        ' 設定されている場合、イベントは発生しません。
    End Sub
       
</script>